PSmartObject Class Reference

This is the base class for objects that use the smart pointer system. More...

`#include <smartptr.h>`

Inheritance diagram for PSmartObject:

## Public Member Functions

| PSmartObject ()
| Construct a new smart object, subject to a `PSmartPointer` instance referencing it. More...
Public Member Functions inherited from PObject
virtual | ~PObject ()
virtual PObject * | Clone () const
| Create a copy of the class on the heap. More...
virtual PINDEX | HashFunction () const
| This function yields a hash value required by the `PDictionary` class. More...
virtual const char * | GetClass (unsigned ancestor=0) const
| Get the current dynamic type of the object instance. More...
PBoolean | IsClass (const char *cls) const
virtual PBoolean | InternalIsDescendant (const char *clsName) const
| Determine if the dynamic type of the current instance is a descendent of the specified class. More...
virtual Comparison | Compare (const PObject &obj) const
| Compare the two objects and return their relative rank. More...
virtual Comparison | CompareObjectMemoryDirect (const PObject &obj) const
| Determine the byte wise comparison of two objects. More...
bool | operator== (const PObject &obj) const
| Compare the two objects. More...
bool | operator!= (const PObject &obj) const
| Compare the two objects. More...
bool | operator< (const PObject &obj) const
| Compare the two objects. More...
bool | operator> (const PObject &obj) const
| Compare the two objects. More...
bool | operator<= (const PObject &obj) const
| Compare the two objects. More...
bool | operator>= (const PObject &obj) const
| Compare the two objects. More...
virtual void | PrintOn (ostream &strm) const
| Output the contents of the object to the stream. More...
virtual void | ReadFrom (istream &strm)
| Input the contents of the object from the stream. More...

## Protected Attributes

PAtomicInteger | referenceCount
| Count of number of instances of `PSmartPointer` that currently reference the object instance. More...

## Additional Inherited Members

Public Types inherited from PObject
enum | Comparison { LessThan = -1, EqualTo = 0, GreaterThan = 1 }
| Result of the comparison operation performed by the `Compare()` function. More...
Static Public Member Functions inherited from PObject
static const char * | Class ()
| Get the name of the class as a C string. More...
static Comparison | InternalCompareObjectMemoryDirect (const PObject *obj1, const PObject *obj2, PINDEX size)
| Internal function caled from CompareObjectMemoryDirect() More...
Protected Member Functions inherited from PObject
| PObject ()
| Constructor for PObject, made protected so cannot ever create one on its own. More...

## Detailed Description

This is the base class for objects that use the smart pointer system.

In conjunction with the `PSmartPointer` class, this class creates objects that can have the automatic deletion of the object instance when there are no more smart pointer instances pointing to it.

A `PSmartObject` carries the reference count that the `PSmartPointer` requires to determine if the pointer is needed any more and should be deleted.

## Constructor & Destructor Documentation

## PSmartObject()

PSmartObject::PSmartObject | ( |  | ) |

inline

Construct a new smart object, subject to a `PSmartPointer` instance referencing it.

## Member Data Documentation

## referenceCount

PAtomicInteger PSmartObject::referenceCount

protected

Count of number of instances of `PSmartPointer` that currently reference the object instance.

The documentation for this class was generated from the following file:

- smartptr.h